<?php

namespace App\Http\Controllers;

use App\Models\Foto;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class FotoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Foto::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Foto())->getFillable());
        $foto = Foto::create($payload);

        return response()->json([
            'success' => true,
            'data' => $foto,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Foto $foto): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $foto,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Foto $foto): JsonResponse
    {
        $payload = $request->only((new Foto())->getFillable());
        $foto->update($payload);

        return response()->json([
            'success' => true,
            'data' => $foto,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Foto $foto): JsonResponse
    {
        $foto->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}